## netproc 0.5.5

=== Makefile ===

# https://www.gnu.org/software/make/manual/make.html#Pattern-Examples
# http://wiki.inf.ufpr.br/maziero/doku.php?id=prog2:o_sistema_make

# CC				compilador a ser usado
# CPPFLAGS	opções para o preprocessador (-DDEBUG ou -I $(DIR_INCLUDES))
# CFLAGS		opções para o compilador (-std=c99)
# LDFLAGS		opções para o ligador (-static -L/opt/opencv/lib)
# LDLIBS		bibliotecas a ligar ao código gerado (-lpthreads -lmath)


# $@ - representa o alvo
# $^ - representa a lista de dependencia
# $< - representa a primeira dependencia

# alvo: dependencia
# <tab>regra

PROG_NAME=netproc

PATH_DOC_INSTALL=$(DESTDIR)/usr/local/share/man/man8
PATH_INSTALL=$(DESTDIR)/usr/local/sbin

SRC=./src
BIN=./bin
DOC=./doc

CC=gcc
# CPPFLAGS=
# CFLAGS=

# environment var
ifdef DEBUG
	CFLAGS+=-Wall -Wextra -pedantic -pedantic-errors -O0 -g
else
	CPPFLAGS=-D NDEBUG
	CFLAGS+= -O2 -march=native -Wall -Wextra
endif

LDLIBS=-lncurses -lpthread

#.c files
C_SOURCE=$(wildcard $(SRC)/*.c)
C_SOURCE+=$(wildcard $(SRC)/resolver/*.c)
#
# .h files
H_SOURCE=$(wildcard $(SRC)/*.h)
H_SOURCE+=$(wildcard $(SRC)/resolver/*.h)
#
# Object files
# todos arquivos .c trocado a extensão para .o
OBJECTS=$(C_SOURCE:.c=.o)

# alvos fake, não são arquivos
.PHONY: all clean distclean run install uninstall format man

all: $(BIN)/$(PROG_NAME)

# linka os arquivos ojetos para o executavel
# regra ja é implitica dessa forma,
# adicionado apenas para 'clareza'
$(BIN)/$(PROG_NAME): $(OBJECTS)
	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@

# mascara generica para compilar arquivos .o
# utiliza todos os arquivos headers como dependencia,
# caso algum seja atualizado, todo os objetos são recompilados
%.o: %.c $(H_SOURCE)
	 $(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@

clean:
	@ find . -type f -name '*.o' -delete
	@ echo "Object files removed"

distclean: clean
	@ find $(BIN) -name $(PROG_NAME) -delete
	@ echo "Removed "$(BIN)"/"$(PROG_NAME)

run:
	sudo $(BIN)/$(PROG_NAME)

# check if user has root privileges.
define checkifroot
  if [ `id -u` -ne 0 ]; then \
    echo 'Need root privileges!'; \
    exit 1; \
  fi
endef

define checkbin
	if [ ! -e $(1) ]; then \
		echo $(1)" not exist, try \"make\"."; \
		exit 1; \
	fi
endef


install:
	@$(call checkifroot)
	@$(call checkbin, $(BIN)/$(PROG_NAME))
	@ install -d -m 755 $(PATH_INSTALL)
	@ install --strip $(BIN)/$(PROG_NAME) $(PATH_INSTALL); \
	echo "Binary instaled in "$(PATH_INSTALL)"/"$(PROG_NAME)
	@install -d -m 755 $(PATH_DOC_INSTALL)
	@install -g 0 -o 0 -m 0644 $(DOC)/$(PROG_NAME).8 $(PATH_DOC_INSTALL); \
	gzip -9 $(PATH_DOC_INSTALL)/$(PROG_NAME).8 ; \
	echo "Man page instaled in "$(PATH_DOC_INSTALL)/$(PROG_NAME)".8.gz"

uninstall:
	@$(call checkifroot)
	@ find $(PATH_DOC_INSTALL) $(PATH_INSTALL) -type f -name "$(PROG_NAME)*" \
	-delete -exec echo "Removed "{} \;

format:
	@ echo "Formating code"
	@ clang-format -i $(SRC)/*.[ch]
	@ clang-format -i $(SRC)/resolver/*.[ch]

man:
	txt2man -t netproc -v "netproc man" -s 8 $(DOC)/netproc.8.txt > $(DOC)/netproc.8

=== debian/changelog ===
netproc (0.5.5-1) unstable; urgency=low

  * Initial release. (Closes: #983520)
   - Fix location install in makefile.
   - Removed CFLAGS -march=native in makefile.
   - Removed directory and root check in makefile.

 -- Mayco Souza Berghetti <mayco.s.berghetti@gmail.com>  Wed, 24 Feb 2021 16:09:22 +0000

=== debian/control ===
Source: netproc
Section: net
Priority: optional
Maintainer: Mayco Souza Berghetti <mayco.s.berghetti@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 libncurses-dev (>= 6.1),
Standards-Version: 4.5.1
Homepage: https://github.com/berghetti/netproc

Package: netproc
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: tool to monitor network usage by processes
 netproc monitors network traffic and tries to find out which process
 this traffic belongs to, this is useful to identify the processes that
 are consuming network resources and troubleshooting.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -fPIE -D_FORTIFY_SOURCE=2
export DEB_LDFLAGS_MAINT_APPEND = -fPIE -pie

%:
	dh $@

## netproc 0.6.3

=== Makefile ===

# https://www.gnu.org/software/make/manual/make.html#Pattern-Examples
# http://wiki.inf.ufpr.br/maziero/doku.php?id=prog2:o_sistema_make

# CC				compilador a ser usado
# CPPFLAGS	opções para o preprocessador (-DDEBUG ou -I $(DIR_INCLUDES))
# CFLAGS		opções para o compilador (-std=c99)
# LDFLAGS		opções para o ligador (-static -L/opt/opencv/lib)
# LDLIBS		bibliotecas a ligar ao código gerado (-lpthreads -lmath)

# https://www.gnu.org/software/make/manual/make.html#Automatic-Variables
# $@ - representa o alvo
# $^ - representa a lista de dependencia
# $< - representa a primeira dependencia

# alvo: dependencia
# <tab>regra

PROG_NAME=netproc

prefix ?= /usr/local

PATH_DOC_INSTALL=$(DESTDIR)$(prefix)/share/man/man8
PATH_INSTALL=$(DESTDIR)$(prefix)/sbin

SRCDIR=./src
OBJDIR=./obj
BINDIR=./bin
DOCDIR=./doc

CC ?= gcc
CFLAGS+= -Wall -Wextra -pedantic

# environment var
ifdef DEBUG
	CFLAGS+= -O0 -ggdb -Wformat=2
else
	CPPFLAGS+=-D NDEBUG
	CFLAGS+= -O2
endif

LDLIBS=$(shell ncurses6-config --libs 2> /dev/null)

ifeq ( $(LDLIBS), )
	LDLIBS=$(shell  ncurses5-config --libs 2> /dev/null)  
endif

LDLIBS += -lpthread

#.c files all subdirectories
C_SOURCE= $(wildcard $(SRCDIR)/*.c) $(wildcard $(SRCDIR)/*/*.c)

# .h files all subdirectories
H_SOURCE=$(wildcard $(SRCDIR)/*.h) $(wildcard $(SRCDIR)/*/*.h)

# https://www.gnu.org/software/make/manual/make.html#General-Search
# search path prerequisits
VPATH= src src/resolver

# Object files
# todos arquivos .c trocado a extensão para .o
# transforma 'src/foo.c' em 'obj/foo.o'
OBJECTS=$(addprefix $(OBJDIR)/, $(notdir $(C_SOURCE:.c=.o) ) )

# alvos fake, não são arquivos
.PHONY: all clean distclean run install uninstall format man release

all: $(BINDIR)/$(PROG_NAME)

# linka os arquivos ojetos para o executavel
# regra ja é implitica dessa forma,
# adicionado apenas para 'clareza'

$(BINDIR)/$(PROG_NAME): $(OBJECTS)
	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@

# mascara generica para compilar arquivos .o
# utiliza todos os arquivos headers como dependencia,
# caso algum seja atualizado, todo os objetos são recompilados

$(OBJDIR)/%.o: %.c $(H_SOURCE)
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@

clean:
	@ find . -type f -name '*.o' -delete
	@ echo "Object files removed"

distclean: clean
	@ find $(BINDIR) -name $(PROG_NAME) -delete
	@ echo "Removed "$(BINDIR)"/"$(PROG_NAME)

run:
	sudo $(BINDIR)/$(PROG_NAME)

install:
	@ install -d -m 755 $(PATH_INSTALL)
	@ install --strip $(BINDIR)/$(PROG_NAME) $(PATH_INSTALL); \
		echo "Binary instaled in "$(PATH_INSTALL)"/"$(PROG_NAME)
	@ install -d -m 755 $(PATH_DOC_INSTALL)
	@ install -g 0 -o 0 -m 0644 $(DOCDIR)/$(PROG_NAME).8 $(PATH_DOC_INSTALL); \
		gzip -9 -f $(PATH_DOC_INSTALL)/$(PROG_NAME).8 ; \
		echo "Man page instaled in "$(PATH_DOC_INSTALL)/$(PROG_NAME)".8.gz"

uninstall:
	@ find $(PATH_DOC_INSTALL) $(PATH_INSTALL) -type f -name "$(PROG_NAME)*" \
		-delete -exec echo "Removed "{} \;

format:
	@ echo "Formating code"
	@ clang-format -i $(SRCDIR)/*.[ch]
	@ clang-format -i $(SRCDIR)/*/*.[ch]
	@ clang-format -i tests/*.[ch]

man:
	txt2man -t $(PROG_NAME) -v "$(PROG_NAME) man" -s 8 \
		$(DOCDIR)/$(PROG_NAME).8.txt > $(DOCDIR)/$(PROG_NAME).8

VERSION = $(shell ./get_version.sh)
tarball:
	git archive -o "netproc-$(VERSION).tar.gz" $(VERSION)

=== tests/Makefile ===

# specific unity, only append this variables
C_SOURCE= ./unity/unity.c
INC_DIRS= -Iunity

CFLAGS=-Wall -Wextra -pedantic -ggdb -O2

INC_DIRS += -I../src -I ../src/resolver

C_TMP= $(wildcard ./test*.c)
OBJS= $(C_TMP:.c=.o)

TEST = tests_all

# include here source module to test
C_SOURCE += ../src/hashtable.c \
 						../src/full_read.c \
						../src/resolver/queue.c \
						../src/str.c \
						../src/rate.c \
						../src/round.c \
						../src/human_readable.c \
						../src/vector.c \
						../src/timer.c

.PHONY: all clean run

all: $(TEST) run clean

$(TEST): $(OBJS)
	$(CC) $(LDFLAGS) $(C_SOURCE) $^ $(LDLIBS) -o $@

%.o : %.c
	$(CC) $(CFLAGS) $(INC_DIRS) $(CPPFLAGS) -c $< -o $@

run:
	- ./$(TEST)

clean:
	@ find . -type f -name '*.o' -delete
#	@ find . -executable -type f -delete

=== debian/changelog ===
netproc (0.6.3-1) unstable; urgency=medium

  * New upstream release.
  * debian rules:
    - Add override_dh_auto_install.
  * debian/patches removed.
  * debian/control:
    - Changed Standards Version to 4.6.0.
    - Add Rules-Requires-Root: no.
  * debian/coptright:
    - add Upstream-Contact.
  * Add file debian/upstream/metadata.

 -- Mayco Souza Berghetti <mayco.s.berghetti@gmail.com>  Sun, 12 Dec 2021 21:19:44 +0000

## netproc 0.6.6

=== Makefile ===
--- 
+++ 
@@ -29,20 +29,25 @@
 DOCDIR=./doc
 
 CC ?= gcc
-CFLAGS+= -Wall -Wextra -pedantic
+CFLAGS += -Wall -Wextra -pedantic -Wformat=2
 
 # environment var
 ifdef DEBUG
-	CFLAGS+= -O0 -ggdb -Wformat=2
+	CFLAGS += -O0 -ggdb -fsanitize=address
+	LDFLAGS += -fsanitize=address
+else ifdef DEV
+	CFLAGS += -O0 -ggdb
 else
-	CPPFLAGS+=-D NDEBUG
-	CFLAGS+= -O2
+	CPPFLAGS += -D NDEBUG
+	CFLAGS += -O2 -flto
+	LDFLAGS += -s -O2 -flto
 endif
 
-LDLIBS=$(shell ncurses6-config --libs 2> /dev/null)
+LDLIBS=$(shell ncursesw6-config --libs 2> /dev/null)
 
-ifeq ( $(LDLIBS), )
-	LDLIBS=$(shell  ncurses5-config --libs 2> /dev/null)  
+# if LDLIBS is empty
+ifeq ($(LDLIBS),)
+	LDLIBS=$(shell  ncursesw5-config --libs 2> /dev/null)
 endif
 
 LDLIBS += -lpthread
@@ -63,7 +68,7 @@
 OBJECTS=$(addprefix $(OBJDIR)/, $(notdir $(C_SOURCE:.c=.o) ) )
 
 # alvos fake, não são arquivos
-.PHONY: all clean distclean run install uninstall format man release
+.PHONY: all clean distclean run install uninstall format man tarball
 
 all: $(BINDIR)/$(PROG_NAME)

=== tests/Makefile ===
--- 
+++ 
@@ -3,12 +3,13 @@
 C_SOURCE= ./unity/unity.c
 INC_DIRS= -Iunity
 
-CFLAGS=-Wall -Wextra -pedantic -ggdb -O2
+CFLAGS=-Wall -Wextra -pedantic -ggdb -O0 -fsanitize=address
+LDFLAGS+= -fsanitize=address
 
 INC_DIRS += -I../src -I ../src/resolver
 
 C_TMP= $(wildcard ./test*.c)
-OBJS= $(C_TMP:.c=.o)
+OBJS_TEST= $(C_TMP:.c=.o)
 
 TEST = tests_all
 
@@ -21,14 +22,17 @@
 						../src/round.c \
 						../src/human_readable.c \
 						../src/vector.c \
-						../src/timer.c
+						../src/timer.c \
+						../src/m_error.c
+
+OBJS_MODS = $(C_SOURCE:.c=.o)
 
 .PHONY: all clean run
 
 all: $(TEST) run clean
 
-$(TEST): $(OBJS)
-	$(CC) $(LDFLAGS) $(C_SOURCE) $^ $(LDLIBS) -o $@
+$(TEST): $(OBJS_TEST) $(OBJS_MODS)
+	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@
 
 %.o : %.c
 	$(CC) $(CFLAGS) $(INC_DIRS) $(CPPFLAGS) -c $< -o $@

=== debian/changelog ===
netproc (0.6.6-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 09 Nov 2024 08:23:03 +0000

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: netproc
 Section: net
+Rules-Requires-Root: no
 Priority: optional
 Maintainer: Mayco Souza Berghetti <mayco.s.berghetti@gmail.com>
 Build-Depends:
  debhelper-compat (= 13),
  libncurses-dev (>= 6.1),
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/berghetti/netproc
 
 Package: netproc

=== debian/rules ===
--- 
+++ 
@@ -7,3 +7,6 @@
 
 %:
 	dh $@
+
+override_dh_auto_install:
+	dh_auto_install -- prefix=/usr

=== debian/watch ===
version=4
opts="mode=git,pgpmode=gittag" \
https://github.com/berghetti/netproc.git refs/tags/[a-z\-]*([\d\.]+)
